#ifndef MATERIALHEADER
#define MATERIALHEADER

#include <windows.h>
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include <string>
#include <map>

class Material  
{
public:
	Material();
	virtual ~Material();
	void setAmbient(float* vals);
	void setSpecular(float* vals);
	void setDiffuse(float* vals);
	void setEmissive(float* vals);

	void setAmbient(float r,float g, float b);
	void setSpecular(float r,float g, float b);
	void setDiffuse(float r,float g, float b);
	void setEmissive(float r,float g, float b);


	void setShininess(float vals);
	bool setTexture(const char * filename, bool flip);

	void apply();

	static void applyDefault();
	static Material * CreateManagedMaterial(const char * name);
	static void ReleaseManagedMaterial(const char * name);
	static void ApplyManagedMaterial(const char * name);
	static Material * GetManagedMaterial(const char * name);

	static std::map<std::string,Material> managedMaterials;


protected:
	std::string _name;

    float _ambient[4];   
    float _diffuse[4];   
    float _specular[4];  
    float _emissive[4];  
    float _shininess;    
	std::string _texture;


	bool _textureLoaded;
	unsigned int _textureName; //gl name for the texture
};

#endif
