#ifndef MESHHEADER
#define MESHHEADER
#include "RenderableObject.h"

class Mesh : public RenderableObject
{
public:
	Mesh();
	~Mesh();
	void Draw();
	bool LoadObj(const char* filename);

private:
protected:

	typedef struct
	{
		int v[4];
		int t[4];
		int n[4];
		bool isTriangle;
	} facedef;
	
	typedef struct
	{
		float x,y,z;
	} vec3;

	typedef struct
	{
		float x,y;
	} vec2;

	int numvertices;
	vec3 * vertices;

	int numtvertices;
	vec2 * tvertices;

	int numnormals;
	vec3 * normals;

	int numfaces;
	facedef * faces;

	bool usetextures;
	bool usenormals;
	int numTriangles;
};
#endif